<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: pegasos_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pegasos_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2009  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_PEGASoS_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_PEGASoS_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;function_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;kernel_abstract.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> kern_type</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        &gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">class </span>svm_pegasos</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">typedef</span> kern_type kernel_type;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type scalar_type;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keyword">typedef</span> decision_function&lt;kernel_type&gt; trained_function_type;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> K_&gt;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">struct </span>rebind {</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            <span class="keyword">typedef</span> svm_pegasos&lt;K_&gt; other;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        };</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        svm_pegasos (</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        );</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        svm_pegasos (</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_, </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            <span class="keyword">const</span> scalar_type&amp; lambda_,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keyword">const</span> scalar_type&amp; tolerance_,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_num_sv</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        );</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        );</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keyword">const</span> scalar_type get_lambda_class1 (</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">const</span> scalar_type get_lambda_class2 (</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keyword">const</span> scalar_type get_tolerance (</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_max_num_sv (</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keyword">const</span> kernel_type get_kernel (</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keywordtype">void</span> set_kernel (</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            kernel_type k</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        );</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordtype">void</span> set_tolerance (</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="keywordtype">double</span> tol</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        );</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordtype">void</span> set_max_num_sv (</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_num_sv</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        );</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keywordtype">void</span> set_lambda (</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            scalar_type lambda_</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        );</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordtype">void</span> set_lambda_class1 (</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            scalar_type lambda_</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        );</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordtype">void</span> set_lambda_class2 (</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            scalar_type lambda_</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        );</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_train_count (</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        scalar_type train (</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            <span class="keyword">const</span> sample_type&amp; x,</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            <span class="keyword">const</span> scalar_type&amp; y</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        );</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        scalar_type operator() (</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            <span class="keyword">const</span> sample_type&amp; x</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <span class="keyword">const</span> decision_function&lt;kernel_type&gt; get_decision_function (</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            svm_pegasos&amp; item</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        );</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    }; </div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160; </div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160; </div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keyword">typename</span> kern_type </div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        &gt;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordtype">void</span> swap(</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        svm_pegasos&lt;kern_type&gt;&amp; a, </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        svm_pegasos&lt;kern_type&gt;&amp; b</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">typename</span> kern_type</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        &gt;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <span class="keyword">const</span> svm_pegasos&lt;kern_type&gt;&amp; item,</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        std::ostream&amp; out</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    );</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        <span class="keyword">typename</span> kern_type </div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        &gt;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        svm_pegasos&lt;kern_type&gt;&amp; item,</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        std::istream&amp; in </div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    );</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160; </div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keyword">typename</span> U</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        &gt;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="keywordtype">void</span> replicate_settings (</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        <span class="keyword">const</span> svm_pegasos&lt;T&gt;&amp; source,</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;        svm_pegasos&lt;U&gt;&amp; dest</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    );</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160; </div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;        <span class="keyword">typename</span> trainer_type</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        &gt;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <span class="keyword">class </span>batch_trainer </div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    {</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::kernel_type kernel_type;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::scalar_type scalar_type;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::sample_type sample_type;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> trainer_type::trained_function_type trained_function_type;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160; </div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160; </div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        batch_trainer (</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        );</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        batch_trainer (</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;            <span class="keyword">const</span> trainer_type&amp; online_trainer, </div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;            <span class="keyword">const</span> scalar_type min_learning_rate_,</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;            <span class="keywordtype">bool</span> verbose_,</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            <span class="keywordtype">bool</span> use_cache_,</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;            <span class="keywordtype">long</span> cache_size_ = 100</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;        );</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        <span class="keyword">const</span> scalar_type get_min_learning_rate (</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;            <span class="keyword">typename</span> in_sample_vector_type,</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;            <span class="keyword">typename</span> in_scalar_vector_type</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;            &gt;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="keyword">const</span> decision_function&lt;kernel_type&gt; train (</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;            <span class="keyword">const</span> in_sample_vector_type&amp; x,</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <span class="keyword">const</span> in_scalar_vector_type&amp; y</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    }; </div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160; </div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160; </div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;        <span class="keyword">typename</span> trainer_type</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        &gt;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;    <span class="keyword">const</span> batch_trainer&lt;trainer_type&gt; batch (</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        <span class="keyword">const</span> <span class="keyword">typename</span> trainer_type::scalar_type min_learning_rate = 0.1</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;    ) { <span class="keywordflow">return</span> batch_trainer&lt;trainer_type&gt;(trainer, min_learning_rate, <span class="keyword">false</span>, <span class="keyword">false</span>); }</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160; </div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;        <span class="keyword">typename</span> trainer_type</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        &gt;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    <span class="keyword">const</span> batch_trainer&lt;trainer_type&gt; verbose_batch (</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        <span class="keyword">const</span> <span class="keyword">typename</span> trainer_type::scalar_type min_learning_rate = 0.1</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;    ) { <span class="keywordflow">return</span> batch_trainer&lt;trainer_type&gt;(trainer, min_learning_rate, <span class="keyword">true</span>, <span class="keyword">false</span>); }</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160; </div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;        <span class="keyword">typename</span> trainer_type</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;        &gt;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    <span class="keyword">const</span> batch_trainer&lt;trainer_type&gt; batch_cached (</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;        <span class="keyword">const</span> <span class="keyword">typename</span> trainer_type::scalar_type min_learning_rate = 0.1,</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;        <span class="keywordtype">long</span> cache_size = 100</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;    ) { <span class="keywordflow">return</span> batch_trainer&lt;trainer_type&gt;(trainer, min_learning_rate, <span class="keyword">false</span>, <span class="keyword">true</span>, cache_size); }</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160; </div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        <span class="keyword">typename</span> trainer_type</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;        &gt;</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;    <span class="keyword">const</span> batch_trainer&lt;trainer_type&gt; verbose_batch_cached (</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        <span class="keyword">const</span> <span class="keyword">typename</span> trainer_type::scalar_type min_learning_rate = 0.1,</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        <span class="keywordtype">long</span> cache_size = 100</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;    ) { <span class="keywordflow">return</span> batch_trainer&lt;trainer_type&gt;(trainer, min_learning_rate, <span class="keyword">true</span>, <span class="keyword">true</span>, cache_size); }</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160; </div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160; </div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;}</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160; </div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;<span class="preprocessor">#endif // DLIB_PEGASoS_ABSTRACT_</span></div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160; </div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
